japa.parser.ast.body

## Class ClassOrInterfaceDeclaration

- java.lang.Object
- - japa.parser.ast.Node
  - - japa.parser.ast.body.BodyDeclaration
    - - japa.parser.ast.body.TypeDeclaration
      - - japa.parser.ast.body.ClassOrInterfaceDeclaration

    public final class ClassOrInterfaceDeclaration
    extends TypeDeclaration

### Constructor Summary

Constructors
Constructor and Description
`ClassOrInterfaceDeclaration()`
`ClassOrInterfaceDeclaration(int modifiers, boolean isInterface, String name)`
`ClassOrInterfaceDeclaration(int beginLine, int beginColumn, int endLine, int endColumn, JavadocComment javaDoc, int modifiers, List<AnnotationExpr> annotations, boolean isInterface, String name, List<TypeParameter> typeParameters, List<ClassOrInterfaceType> extendsList, List<ClassOrInterfaceType> implementsList, List<BodyDeclaration> members)`
`ClassOrInterfaceDeclaration(JavadocComment javaDoc, int modifiers, List<AnnotationExpr> annotations, boolean isInterface, String name, List<TypeParameter> typeParameters, List<ClassOrInterfaceType> extendsList, List<ClassOrInterfaceType> implementsList, List<BodyDeclaration> members)`

### Method Summary

Methods
`<R,A> R` `accept(GenericVisitor<R,A> v, A arg)` Accept method for visitor support.
`<A> void` `accept(VoidVisitor<A> v, A arg)` Accept method for visitor support.
`List<ClassOrInterfaceType>` `getExtends()`
`List<ClassOrInterfaceType>` `getImplements()`
`List<TypeParameter>` `getTypeParameters()`
`boolean` `isInterface()`
`void` `setExtends(List<ClassOrInterfaceType> extendsList)`
`void` `setImplements(List<ClassOrInterfaceType> implementsList)`
`void` `setInterface(boolean interface_)`
`void` `setTypeParameters(List<TypeParameter> typeParameters)`

### Methods inherited from class japa.parser.ast.body.TypeDeclaration

`getMembers, getModifiers, getName, setMembers, setModifiers, setName`

### Methods inherited from class japa.parser.ast.body.BodyDeclaration

`getAnnotations, getJavaDoc, setAnnotations, setJavaDoc`

### Methods inherited from class japa.parser.ast.Node

`equals, getBeginColumn, getBeginLine, getData, getEndColumn, getEndLine, hashCode, setBeginColumn, setBeginLine, setData, setEndColumn, setEndLine, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ClassOrInterfaceDeclaration

    public ClassOrInterfaceDeclaration()

#### ClassOrInterfaceDeclaration

    public ClassOrInterfaceDeclaration(int modifiers,
                               boolean isInterface,
                               String name)

#### ClassOrInterfaceDeclaration

    public ClassOrInterfaceDeclaration(JavadocComment javaDoc,
                               int modifiers,
                               List<AnnotationExpr> annotations,
                               boolean isInterface,
                               String name,
                               List<TypeParameter> typeParameters,
                               List<ClassOrInterfaceType> extendsList,
                               List<ClassOrInterfaceType> implementsList,
                               List<BodyDeclaration> members)

#### ClassOrInterfaceDeclaration

    public ClassOrInterfaceDeclaration(int beginLine,
                               int beginColumn,
                               int endLine,
                               int endColumn,
                               JavadocComment javaDoc,
                               int modifiers,
                               List<AnnotationExpr> annotations,
                               boolean isInterface,
                               String name,
                               List<TypeParameter> typeParameters,
                               List<ClassOrInterfaceType> extendsList,
                               List<ClassOrInterfaceType> implementsList,
                               List<BodyDeclaration> members)

### Method Detail

#### accept

    public <R,A> R accept(GenericVisitor<R,A> v,
                 A arg)

Description copied from class: `Node`
Accept method for visitor support.

Specified by:
  `accept` in class `Node`
Type Parameters:
  `R` - the type the return value of the visitor
  `A` - the type the argument passed for the visitor
Parameters:
  `v` - the visitor implementation
  `arg` - any value relevant for the visitor
Returns:
  the result of the visit

#### accept

    public <A> void accept(VoidVisitor<A> v,
                  A arg)

Description copied from class: `Node`
Accept method for visitor support.

Specified by:
  `accept` in class `Node`
Type Parameters:
  `A` - the type the argument passed for the visitor
Parameters:
  `v` - the visitor implementation
  `arg` - any value relevant for the visitor

#### getExtends

    public List<ClassOrInterfaceType> getExtends()

#### getImplements

    public List<ClassOrInterfaceType> getImplements()

#### getTypeParameters

    public List<TypeParameter> getTypeParameters()

#### isInterface

    public boolean isInterface()

#### setExtends

    public void setExtends(List<ClassOrInterfaceType> extendsList)

#### setImplements

    public void setImplements(List<ClassOrInterfaceType> implementsList)

#### setInterface

    public void setInterface(boolean interface_)

#### setTypeParameters

    public void setTypeParameters(List<TypeParameter> typeParameters)